import flash.display.MovieClip;
import flash.display.Sprite;
import flash.display.DisplayObjectContainer;
import flash.events.TimerEvent;
import flash.utils.Timer;

class ShipBadBlueBomb extends FlyingObject {
	var secondTimer : Timer;
	var maxTime : Int;

	override function setExtraVars() {
		name = "bluebomb";

		maxTime = 8;
		secondTimer = new Timer(Std.random(20) * 100 + 2000);
		secondTimer.addEventListener(TimerEvent.TIMER, endMove);
		secondTimer.start();
	}

	override function setHitArea() {
		hitArea = new Sprite();

		//hitArea.graphics.beginFill(0x50FF0000);
		hitArea.graphics.moveTo(20, 5);
		hitArea.graphics.lineTo(35, 30);
		hitArea.graphics.lineTo(5, 30);
		hitArea.graphics.lineTo(20, 5);
		//hitArea.graphics.endFill();

		this.addChild(hitArea);
	}

	function endMove(e : TimerEvent) {
		secondTimer.stop();
		secondTimer.removeEventListener(TimerEvent.TIMER, endMove);

		speed = 0;

		secondTimer.delay = 150;
		secondTimer.reset();
		secondTimer.addEventListener(TimerEvent.TIMER, secondElapsed);
		secondTimer.start();
	}

	function secondElapsed(e : TimerEvent) {
		if (secondTimer.currentCount >= maxTime) {
			secondTimer.stop();
			secondTimer.removeEventListener(TimerEvent.TIMER, secondElapsed);

			new Explosion(stage, GContext.explosion, centerX, centerY, 400, 10);
			addWeapon(new WeaponGuide12("clearbomb", this, 1000));
			for (p in fire()) {
				stage.addChild(p);
				GContext.badProjectile.push(p);
			}

			removeSelf();
		}
		else {
			rotationSpeed *= 1.5;
		}
	}

	override public function removeSelf() {
		secondTimer.stop();
		secondTimer.removeEventListener(TimerEvent.TIMER, endMove);
		secondTimer.removeEventListener(TimerEvent.TIMER, secondElapsed);

		state = "toRemove";
	}

}

