import flash.display.DisplayObjectContainer;
import flash.events.TimerEvent;
import flash.utils.Timer;



class Explosion extends FlyingObject {
	public var stageRef : DisplayObjectContainer;
	public var explosionArray : Array<FlyingObject>;
	var subFactor : Float;		// nombre de sous explosions
	var duration : Float;
	var imploseOn : Bool;
	var imploseTimer : Timer;

	public function new(
			stageRef : DisplayObjectContainer, 
			eArray : Array<FlyingObject>, 
			cx : Float, 
			cy : Float, 
			duration : Float = 300, 
			subFactor : Float = 0) {

		super(cx, cy);

		this.stageRef = stageRef;
		this.explosionArray = eArray;
		this.duration = duration;
		this.subFactor = subFactor;

		scaleX = scaleY = 0.2;
		radius *= 0.2;
		x = centerX + radius * Math.sin(angle);
		y = centerY - radius * Math.cos(angle);
		rotation = 0;

		explosionArray.push(this);
		stageRef.addChild(this);

		imploseOn = false;
		explose(duration);
	}

	override function move() {
		if (exploseOn)
			exploseRender();

		if (imploseOn)
			imploseRender();

		x = centerX + radius * Math.sin(angle + radian);
		y = centerY - radius * Math.cos(angle + radian);

		var dx : Float = Math.random() * bdWidth / 2 - bdWidth / 4;
		var dy : Float = Math.random() * bdHeight / 2 - bdWidth / 4;

		if (subFactor > 1) { 
			new Explosion(
				stageRef, 
				explosionArray, 
				centerX + dx,
				centerY + dy,
				duration / (Std.random(4) + 3), 
				Math.floor(subFactor / 4)
			);
			subFactor--;
		}
	}

	override public function explose(duration : Float) {
		state = "explose";
		exploseOn = true;
		imploseOn = false;
		exploseTimer = new Timer(duration);
		imploseTimer = new Timer(duration);
		exploseTimer.addEventListener(TimerEvent.TIMER, exploseOff);
		imploseTimer.addEventListener(TimerEvent.TIMER, imploseOff);
		exploseTimer.start();
	}


	override function exploseRender() {
		alpha *= 0.85;
		scale(1.2);
	}


	override function exploseOff(e : TimerEvent) {
		exploseOn = false;
		exploseTimer.stop();
		exploseTimer.removeEventListener(TimerEvent.TIMER, exploseOff);

		imploseOn = true;
		imploseTimer.start();
	}

	function imploseRender() {
		alpha *= 0.85;
		scale(0.7);
	}

	function imploseOff(e : TimerEvent) {
		imploseTimer.stop();
		imploseTimer.removeEventListener(TimerEvent.TIMER, imploseOff);
		removeSelf();
	}
}

