

class FlyBehavior {
	var flyer : FlyingObject;
	var outOfScreenBehavior : OutOfScreenBehavior;
	var onBackStage : Bool;
	public var dx : Float;
	public var dy : Float;

	public function new(f : FlyingObject, ?oos : OutOfScreenBehavior) {
		flyer = f;
		if (oos != null)
			outOfScreenBehavior = oos;
		dx = 0;
		dy = 0;
		onBackStage = true;
	}

	public function moveToStage() : Void {
		flyer.centerY += flyer.speed;

		// spinning
		if (flyer.rotationSpeed > 0)
			flyer.rotationRad += flyer.rotationSpeed;
		else
			flyer.rotationRad = flyer.radian;

		// placement du sprite
		flyer.y = flyer.centerY - flyer.radius * Math.cos(flyer.angle + flyer.rotationRad);
		flyer.rotation = 180 * flyer.rotationRad / Math.PI;

		// on stage ?
		if (flyer.centerY > -flyer.bdHeight/2)
			onBackStage = false;
	}

	public function move() : Void {
		if (onBackStage) {
			moveToStage();
			return;
		}

		// deplacement
		dx = flyer.speed * Math.sin(-flyer.radian);
		dy = flyer.speed * Math.cos(flyer.radian);
		flyer.centerX += dx;
		flyer.centerY += dy;

		// spinning
		if (flyer.rotationSpeed > 0)
			flyer.rotationRad += flyer.rotationSpeed;
		else
			flyer.rotationRad = flyer.radian;

		// ajustement en cas de sortie d'ecran
		if (outOfScreenBehavior != null)
			outOfScreenBehavior.hook();
	
		// placement du sprite
		flyer.x = flyer.centerX + flyer.radius * Math.sin(flyer.angle + flyer.rotationRad);
		flyer.y = flyer.centerY - flyer.radius * Math.cos(flyer.angle + flyer.rotationRad);
		flyer.rotation = 180 * flyer.rotationRad / Math.PI;
	}

	public function keyLeft() {}
	public function keyRight() {}
	public function keyUp() {}
	public function keyDown() {}
}
