
class FlyBehaviorGuided extends FlyBehavior {

	public function new(f : FlyingObject, ?oos : OutOfScreenBehavior) {
		super(f, oos);
	}

	override public function move() : Void {
		// nouvelle trajectoire
		if (flyer.target.length != 0 && flyer.target[0] != null) {
			flyer.radian = -Math.atan2(
				flyer.target[0].centerX - flyer.centerX,
				flyer.target[0].centerY - flyer.centerY
			);
		}

		// deplacement
		dx = flyer.speed * Math.sin(-flyer.radian);
		dy = flyer.speed * Math.cos(flyer.radian);

		flyer.centerX += dx;
		flyer.centerY += dy;

		// spinning
		if (flyer.rotationSpeed > 0)
			flyer.rotationRad += flyer.rotationSpeed;
		else
			flyer.rotationRad = flyer.radian;

		// ajustement en cas de sortie d'ecran
		if (outOfScreenBehavior != null)
			outOfScreenBehavior.hook();
	
		// placement du sprite
		flyer.x = flyer.centerX + flyer.radius * Math.sin(flyer.angle + flyer.rotationRad);
		flyer.y = flyer.centerY - flyer.radius * Math.cos(flyer.angle + flyer.rotationRad);
		flyer.rotation = 180 * flyer.rotationRad / Math.PI;

	}
}
