
class FlyBehaviorHorizontal extends FlyBehavior {

	override public function move() : Void {
		// effet de la gravite
		if (flyer.centerY < flyer.stage.stageHeight - flyer.bdHeight)
			dy += flyer.gravityEffect;
	
		// deplacement
		flyer.centerX += dx;
		flyer.centerY += dy;

		// spinning
		flyer.rotationRad += flyer.rotationSpeed;

		// ajustement en cas de sortie d'ecran
		if (outOfScreenBehavior != null)
			outOfScreenBehavior.hook();
	
		// placement du sprite
		flyer.x = flyer.centerX + flyer.radius * Math.sin(flyer.angle + flyer.rotationRad);
		flyer.y = flyer.centerY - flyer.radius * Math.cos(flyer.angle + flyer.rotationRad);
		flyer.rotation = 180 * flyer.rotationRad / Math.PI;

		// effet special
		flyer.rotation += dx * 2;

		// ralentissement 
		dx = (Math.abs(dx) < 0.1) ? 0 : dx *= flyer.easingEffect;
		dy = (Math.abs(dy) < 0.1) ? 0 : dy *= flyer.easingEffect;
	}

	override public function keyLeft() {
		dx -= flyer.speed;
	}

	override public function keyRight() {
		dx += flyer.speed;
	}

	override public function keyUp() {
		dy -= flyer.speed;
	}

	override public function keyDown() {
		dy += flyer.speed;
	}
}
