
class FlyBehaviorRegular extends FlyBehavior {

	override public function move() : Void {
		dx = flyer.speed * Math.sin(-flyer.radian);
		dy = flyer.speed * Math.cos(flyer.radian);

		// effet de la gravite
		if (flyer.centerY < flyer.stage.stageHeight - flyer.bdHeight)
			dy += flyer.gravityEffect;
	
		// deplacement
		flyer.centerX += dx;
		flyer.centerY += dy;

		//spinning
		if (flyer.rotationSpeed > 0)
			flyer.rotationRad += flyer.rotationSpeed;
		else
			flyer.rotationRad = flyer.radian;

		// ajustement en cas de sortie d'ecran
		if (outOfScreenBehavior != null)
			outOfScreenBehavior.hook();
	
		// placement du sprite
		flyer.x = flyer.centerX + flyer.radius * Math.sin(flyer.angle + flyer.rotationRad);
		flyer.y = flyer.centerY - flyer.radius * Math.cos(flyer.angle + flyer.rotationRad);
		flyer.rotation = 180 * flyer.rotationRad / Math.PI;

		// calcul de l'inertie
		flyer.speed = (Math.abs(flyer.speed) < 0.1) ? 0 : flyer.speed *= flyer.easingEffect;
	}

	override public function keyLeft() {
		flyer.radian -= 0.1;
	}

	override public function keyRight() {
		flyer.radian += 0.1;
	}

	override public function keyUp() {
		flyer.speed += 0.5;
	}

	override public function keyDown() {
		flyer.speed -= 0.5;
	}
}
