import flash.events.TimerEvent;
import flash.utils.Timer;


class FlyBehaviorShuriken extends FlyBehavior {
	var waitTimer : Timer;
	var state : String;

	public function new(f : FlyingObject, ?oos : OutOfScreenBehavior) {
		super(f, oos);

		state = "down";
	}

	override public function move() : Void {

		// deplacement
		if (state == "down") {
			dx = flyer.speed / 2 * Math.sin(-flyer.radian);
			dy = flyer.speed / 2 * Math.cos(flyer.radian);
			flyer.centerX += dx;
			flyer.centerY += dy;

			if (flyer.centerY >= flyer.bdHeight) {
				state = "wait";
				flyer.centerY = flyer.bdHeight;

				waitTimer = new Timer(Std.random(1000) + 200);
				waitTimer.addEventListener(TimerEvent.TIMER, goFast);
				waitTimer.start();
			}
		}
		else if (state == "fast") {
			dx = flyer.speed * 4 * Math.sin(-flyer.radian);
			dy = flyer.speed * 4 * Math.cos(flyer.radian);
			flyer.centerX += dx;
			flyer.centerY += dy;

			if (flyer.centerY >= flyer.stage.stageHeight) {
				state = "down";
				flyer.centerY = -flyer.bdHeight;
			}
		}

		// spinning
		if (flyer.rotationSpeed > 0) {
			if (state == "fast")
				flyer.rotationRad += -4 * flyer.rotationSpeed;
			else 
				flyer.rotationRad += flyer.rotationSpeed;
		}
		else
			flyer.rotationRad = flyer.radian;

		// placement du sprite
		flyer.x = flyer.centerX + flyer.radius * Math.sin(flyer.angle + flyer.rotationRad);
		flyer.y = flyer.centerY - flyer.radius * Math.cos(flyer.angle + flyer.rotationRad);
		flyer.rotation = 180 * flyer.rotationRad / Math.PI;
	}

	function goFast(e : TimerEvent) {
		state = "fast";
		waitTimer.stop();
		waitTimer.removeEventListener(TimerEvent.TIMER, goFast);

		move();
	}
}
