
class FlyBehaviorSinusoid extends FlyBehavior {
	public var sinAmp : Float;

	public function new(f : FlyingObject, ?oos : OutOfScreenBehavior, ?sinAmp : Float) {
		super(f, oos);

		if (sinAmp != null)
			this.sinAmp = sinAmp;
		else
			this.sinAmp = 1;
	}

	override public function move() : Void {
		if (onBackStage) {
			moveToStage();
			return;
		}

		// deplacement
		dx = flyer.speed * sinAmp * Math.sin(flyer.centerY/40);
		dy = flyer.speed;
		flyer.centerX += dx;
		flyer.centerY += dy;

		// spinning
		flyer.rotationRad += flyer.rotationSpeed;

		// ajustement en cas de sortie d'ecran
		if (outOfScreenBehavior != null)
			outOfScreenBehavior.hook();
	
		// placement du sprite
		flyer.x = flyer.centerX + flyer.radius * Math.sin(flyer.angle + flyer.rotationRad);
		flyer.y = flyer.centerY - flyer.radius * Math.cos(flyer.angle + flyer.rotationRad);
		flyer.rotation = 180 * flyer.rotationRad / Math.PI;
	}

}
