
class FlyBehaviorT extends FlyBehavior {
	var newRadian : Float;

	public function new(f : FlyingObject, ?oos : OutOfScreenBehavior) {
		super(f, oos);
		newRadian = f.radian;
	}

	override public function move() : Void {
		// nouvelle trajectoire
		if (flyer.centerY < flyer.stage.stageHeight/3) 
			newRadian = 0;
		else 
			if (newRadian == 0)
				newRadian = Math.PI/2;

		// tourne si arrive trop pret d'un bord
		if (flyer.centerX < flyer.bdWidth)
			newRadian = -Math.PI/2;
		else if (flyer.centerX > flyer.stage.stageWidth - flyer.bdWidth)
			newRadian = Math.PI/2;
		
		flyer.radian = newRadian;

		// deplacement
		var dx : Float = flyer.speed * Math.sin(-flyer.radian);
		var dy : Float = flyer.speed * Math.cos(flyer.radian);
		flyer.centerX += dx;
		flyer.centerY += dy;

		// spinning
		if (flyer.rotationSpeed > 0)
			flyer.rotationRad += flyer.rotationSpeed;

		// ajustement en cas de sortie d'ecran
		if (outOfScreenBehavior != null)
			outOfScreenBehavior.hook();
	
		// placement du sprite
		flyer.x = flyer.centerX + flyer.radius * Math.sin(flyer.angle + flyer.rotationRad);
		flyer.y = flyer.centerY - flyer.radius * Math.cos(flyer.angle + flyer.rotationRad);
		flyer.rotation = 180 * flyer.rotationRad / Math.PI;
	}
}
