
class FlyBehaviorUSin extends FlyBehavior {
	var state : String;

	public function new(f : FlyingObject, ?oos : OutOfScreenBehavior) {
		state = "down";
		super(f, oos);
	}

	override public function move() : Void {
		if (onBackStage) {
			moveToStage();
			return;
		}
		
		// nouvelle trajectoire
		switch (state) {
			case "down":
				if (flyer.centerY > (flyer.stage.stageHeight - 4 * flyer.bdHeight)) {
					if (flyer.centerX < flyer.stage.stageWidth/2)
						state = "left2up";
					else
						state = "right2up";
				}

			case "up":
				if (flyer.centerY < flyer.bdHeight) {
					if (flyer.centerX < flyer.stage.stageWidth/2)
						state = "right2down";
					else
						state = "left2down";
				}

			case "left2up":
				if (flyer.centerY <= (flyer.stage.stageHeight - 4 * flyer.bdHeight)) 
					state = "up";

			case "right2up":
				if (flyer.centerY <= (flyer.stage.stageHeight - 4 * flyer.bdHeight)) 
					state = "up";

			case "left2down":
				if (flyer.centerY >= flyer.bdHeight)
					state = "down";

			case "right2down":
				if (flyer.centerY >= flyer.bdHeight)
					state = "down";
			
			default:
				trace("ERROR: UNKNOWN STATE " + state);
		}

		switch (state) {
			case "down":
				flyer.radian = 0;

			case "up":
				flyer.radian = Math.PI;

			case "left2up":
				flyer.radian -= 0.04;

			case "left2down":
				flyer.radian -= 0.04;

			case "right2up":
				flyer.radian += 0.04;

			case "right2down":
				flyer.radian += 0.04;
		}
		

		// deplacement
		if (state == "up" || state == "down") {
			dx = 2 * Math.sin(flyer.centerY/40);
		}
		else {
			dx = flyer.speed * Math.sin(-flyer.radian);
		}
		dy = flyer.speed * Math.cos(flyer.radian);

		flyer.centerX += dx;
		flyer.centerY += dy;


		// spinning
		if (flyer.rotationSpeed > 0)
			flyer.rotationRad += flyer.rotationSpeed;
		else
			flyer.rotationRad = flyer.radian;

		// ajustement en cas de sortie d'ecran
		if (outOfScreenBehavior != null)
			outOfScreenBehavior.hook();
	
		// placement du sprite
		flyer.x = flyer.centerX + flyer.radius * Math.sin(flyer.angle + flyer.rotationRad);
		flyer.y = flyer.centerY - flyer.radius * Math.cos(flyer.angle + flyer.rotationRad);
		flyer.rotation = 180 * flyer.rotationRad / Math.PI;
	}

}
