
class FlyBehaviorZ extends FlyBehavior {
	var newRadian : Float;

	public function new(f : FlyingObject, ?oos : OutOfScreenBehavior) {
		super(f, oos);
	}

	public function init() : Void {
		//flyer.radian = (flyer.x < flyer.stage.stageWidth/2) ? -0.35 * Math.PI : 0.35 * Math.PI;
		flyer.radian = 0.35 * Math.PI;
		newRadian = flyer.radian;
	}

	override public function move() : Void {
		if (onBackStage) {
			moveToStage();
			init();
			return;
		}

		// tourne si arrive pret des bords droits/gauche ou si hors ecran
		if (flyer.centerX < flyer.bdWidth * 1.5) {
			newRadian = -0.35 * Math.PI;
		}
		
		if (flyer.centerX > flyer.stage.stageWidth - flyer.bdWidth * 1.5) {
			newRadian = 0.35 * Math.PI;
		}

		// nouvelle trajectoire
		if (newRadian != flyer.radian) {
			flyer.radian += (newRadian - flyer.radian) * 0.07;
		}

		// deplacement
		var dx : Float = flyer.speed * Math.sin(-flyer.radian);
		var dy : Float = flyer.speed * Math.cos(flyer.radian);
		flyer.centerX += dx;
		flyer.centerY += dy;

		// spinning
		if (flyer.rotationSpeed > 0)
			flyer.rotationRad += flyer.rotationSpeed;
		else
			flyer.rotationRad = flyer.radian;

		// ajustement en cas de sortie d'ecran
		if (outOfScreenBehavior != null)
			outOfScreenBehavior.hook();
	
		// placement du sprite
		flyer.x = flyer.centerX + flyer.radius * Math.sin(flyer.angle + flyer.rotationRad);
		flyer.y = flyer.centerY - flyer.radius * Math.cos(flyer.angle + flyer.rotationRad);
		flyer.rotation = 180 * flyer.rotationRad / Math.PI;
	}

}
