import flash.display.GradientType;
import flash.display.Sprite;
import flash.geom.Matrix;


class FuelBar extends Sprite {
	var nbar : Int;
	var _x : Float;
	var _y : Float;
	var _height : Float;
	var _width : Float;

	public function new(x : Float, y : Float, width : Float, height : Float, n : Int) {
		super();

		nbar = n;
		_x = x;
		_y = y;
		_height = height;
		_width = width;

		update(100);
	}

	public function update(percent : Float) {
		this.graphics.clear();

		percent /= (100/nbar);

		var wbar : Float = _width / nbar;
		var i : Int;
		for (i in 1...(nbar+1)) {
			this.graphics.lineStyle(1, 0xFFFFFF, 0.4);
			if (i <= percent) 
				this.graphics.beginFill(0x0065DE);
			else
				this.graphics.beginFill(0x556080, 0.8);
			this.graphics.drawRect(_x + 1 + wbar * i, _y + 1, wbar - 2, _height - 2);
			this.graphics.endFill();
		}
	}
}
