import flash.display.GradientType;
import flash.display.Sprite;
import flash.geom.Matrix;
import flash.events.TimerEvent;
import flash.utils.Timer;


class LifeBar extends Sprite {
	var matrix : Matrix;
	var _x : Float;
	var _y : Float;
	var _height : Float;
	var _width : Float;
	var fxTimer : Timer;

	public function new(x : Float, y : Float, width : Float, height : Float) {
		super();

		_x = x;
		_y = y;
		_height = height;
		_width = width;

		matrix = new Matrix();
		matrix.createGradientBox(width, height, 0, 0, 0);

		fxTimer = new Timer(0);
		fxTimer.addEventListener(TimerEvent.TIMER, fxOff);

		update(100);
	}

	public function update(percent : Float) {
		this.graphics.clear();

		// rectangle transparent (le cadre)
		this.graphics.lineStyle(2, 0xFFFFFF, 0.4);
		this.graphics.drawRoundRect(_x, _y, _width, _height, 4);

		// barre de vie 
                this.graphics.beginGradientFill(
			GradientType.LINEAR, 
			[0xFF0000, 0xFFFF00, 0x00FF00],
			[1, 1, 1],
			[0, 127, 255],
			matrix
		);
                this.graphics.drawRoundRect(_x, _y, _width * percent / 100, _height, 4);
                this.graphics.endFill();
	}

	public function fxOn(duration : Int) {
		fxTimer.delay = duration;
		fxTimer.start();
		filters = [new flash.filters.GlowFilter(0xFFFFFF, 1.0, 20, 20, 3, 1, false, false)];
	}

	function fxOff(e : TimerEvent) {
		fxTimer.stop();
		filters = null;
	}
}
