import flash.display.Sprite;
import flash.text.TextField;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;
import flash.text.TextFieldAutoSize;
import flash.filters.DropShadowFilter;
import flash.events.TimerEvent;
import flash.utils.Timer;


class MessageField extends Sprite {
	var format : TextFormat;
	var text : TextField;

	var textOn : Bool;
	var textTimer : Timer;

	public function new(x : Float, y : Float) {
		super();

		this.x = x;
		this.y = y;

		format = new TextFormat();
                format.size = 32;
                format.font = "Sans serif";
                format.color = 0xFFFFFF;
                format.bold = true;
                format.align = TextFormatAlign.CENTER;

		text = new TextField();
		text.x = 0;
		text.y = 0;
		text.text = "";
		text.defaultTextFormat = format;
		text.filters = [new flash.filters.GlowFilter(0x0077DD, 1.0, 15, 15, 3, 1, false, false)];
                text.autoSize = TextFieldAutoSize.CENTER;

		textOn = false;
	}


	public function show(s : String, ?duration : Float) {
		text.text = s;
		text.x = - text.width/2;
		textOn = true;
		if (duration != null && duration > 0) {
			textTimer = new Timer(duration);
			textTimer.addEventListener(TimerEvent.TIMER, hide);
			textTimer.start();
		}
		addChild(text);
	}

	public function hide(e : TimerEvent) {
		textTimer.stop();
		textTimer.removeEventListener(TimerEvent.TIMER, hide);
		text.text = "";
		removeChild(text);
	}
}
