

class ProjectileFactory {
	public static function createProjectile(type : String, cx : Float, cy : Float, radian : Float, speed : Float) : Projectile {
		switch(type) {
			case "redcircle":
				return new ProjectileRedCircle(cx, cy, radian, speed);
			case "bluecircle":
				return new ProjectileBlueCircle(cx, cy, radian, speed);
			case "clearbomb":
				return new ProjectileBombClear(cx, cy, radian, speed);
			case "plasma":
				return new ProjectilePlasma(cx, cy, radian, speed);
			case "laser":
				return new ProjectileLaser(cx, cy, radian, speed);
			case "redlaser":
				return new ProjectileRedLaser(cx, cy, radian, speed);
			case "redmine":
				return new ProjectileRedMine(cx, cy, radian, speed);
			default:
				return new ProjectileLaser(cx, cy, radian, speed);
		}
	}
}
