import flash.display.Sprite;
import flash.display.DisplayObjectContainer;
import flash.events.TimerEvent;
import flash.utils.Timer;


class Shield {
	// vaisseau qui contient le bouclier
	public var ship : FlyingObject;

	// duree du bouclier
	var shieldRaiseTimer : Timer;
	var shieldOffTimer : Timer;

	// statut
	public var shieldOn : Bool;

	public function new(ship : FlyingObject) {
		this.ship = ship;

		shieldRaiseTimer = new Timer(0);
		shieldRaiseTimer.addEventListener(TimerEvent.TIMER, shieldRaise);

		shieldOffTimer = new Timer(0);
		shieldOffTimer.addEventListener(TimerEvent.TIMER, shieldOff);
	}


	public function on(duration : Float) {
		ship.filters = [new flash.filters.GlowFilter(0x0099EE, 1.0, 20, 20, 3, 1, false, false)];

		if (shieldOn == false) {
			shieldOn = true;

			shieldRaiseTimer.delay = duration * 0.75;
			shieldOffTimer.delay = duration;

			shieldRaiseTimer.start();
			shieldOffTimer.start();
		}
		else {
			shieldRaiseTimer.delay += duration * 0.75;
			shieldOffTimer.delay += duration;
		}

	}

	function shieldRaise(e : TimerEvent) {
		shieldRaiseTimer.stop();
		ship.filters = [new flash.filters.GlowFilter(0xA0E0FF, 2.0, 20, 20, 3, 1, false, false)];
	}

	function shieldOff(e : TimerEvent) {
		shieldOffTimer.stop();
		shieldOn = false;
		ship.filters = null;
	}
}

