import flash.display.Sprite;


class ShipGood extends FlyingObject {
	public var gravityEffect : Float;
	public var easingEffect : Float;
	var fireBurst : FireBurst;

	public function new(cx : Float, cy : Float, ?radian : Float) {
		super(cx, cy, (radian != null) ? radian : 0);

		fireBurst = new FireBurst();
		fireBurst.x = (bdWidth - fireBurst.width) / 2;
		fireBurst.y = - bdHeight;
		addChild(fireBurst);

		gravityEffect = 0.5;
		easingEffect = 0.95;
	}


	override function setHitArea() {
		hitArea = new Sprite();

		//hitArea.graphics.beginFill(0x00FF00);
		hitArea.graphics.moveTo(5, 5);
		hitArea.graphics.lineTo(35, 5);
		hitArea.graphics.lineTo(35, 20);
		hitArea.graphics.lineTo(5, 20);
		hitArea.graphics.lineTo(5, 5);
		//hitArea.graphics.endFill();

		this.addChild(hitArea);
	}

	override public function move() {
		if (exploseOn)
			exploseRender();

		if (blinkOn)
			blinkRender();

		if (flyBehavior != null)
			flyBehavior.move();

		fireBurst.less();
	}

	public function keyLeft() {
		flyBehavior.keyLeft();
	}

	public function keyRight() {
		flyBehavior.keyRight();
	}

	public function keyUp() {
		flyBehavior.keyUp();
		fireBurst.more();
	}

	public function keyDown() {
		flyBehavior.keyDown();
	}

}
