import flash.display.Sprite;
import flash.display.DisplayObjectContainer;
import flash.media.Sound;


class Weapon {
	// Nom de l'arme
	public var name : String;

	// vaisseau qui contient l'arme
	public var ship : FlyingObject;

	// gestion de la latence entre les tirs
	public var lastFireTime : Float;
	public var fireDelay : Float;

	// description du type de projectile
	public var projectileType : String;
	public var projectileSpeed : Float;

	// son associe
	public var snd : Sound;

	public function new(type : String, ship : FlyingObject, fDelay : Float, ?speed : Float, ?snd : Sound) {
		this.ship = ship;
		projectileType = type;
		fireDelay = fDelay;
		lastFireTime = Std.random(cast(fDelay/2, Int));

		if (speed != null) 
			projectileSpeed = speed;
		else
			projectileSpeed = 10;

		if (snd != null) 
			this.snd = snd;

		name = "weapon";
		setExtraVars();
	}

	function setExtraVars() : Void {}	// fonction abstraite

	public function fire() : Array<FlyingObject> {
		var ret : Array<FlyingObject> = new Array();
		var currentTime : Float = flash.Lib.getTimer();

		if (currentTime > lastFireTime + fireDelay) {
			ret = ret.concat(fireOn());
			if (snd != null) 
				snd.play();
		}
		
		if (ret.length > 0) 
			lastFireTime = currentTime;

		return ret;
	}


	public function fireOn() : Array<FlyingObject> {	// fonction abstraite
		var ret : Array<FlyingObject> = new Array();
		return ret;
	}
}

